package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.TestAaa;
import com.izouma.awesomeadmin.service.TestAaaService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/testAaa")
public class TestAaaController {

    @Autowired
    private TestAaaService testAaaService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(TestAaa record) {
        List<TestAaa> pp = testAaaService.getTestAaaList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getTestAaa", method = RequestMethod.GET)
    @ResponseBody
    public Result getTestAaa(@RequestParam(required = false, value = "id") String id) {
        TestAaa data = testAaaService.getTestAaaById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(TestAaa record) {
        TestAaa data = testAaaService.getTestAaa(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, TestAaa record) {
        Map<String, Object> result = new HashMap<>();

        List<TestAaa> pp =testAaaService.getTestAaaByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(TestAaa record) {
        boolean num = testAaaService.createTestAaa(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateTestAaa(TestAaa record) {
        boolean num = testAaaService.updateTestAaa(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteTestAaa(@RequestParam(required = true, value = "id") String id) {

        boolean num = testAaaService.deleteTestAaa(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, TestAaa record) throws Exception {

    List<TestAaa> testAaas = testAaaService.getTestAaaList(record);


        String sheetName = "test_aaa";
        String titleName = "test_aaa数据表";
        String fileName = "test_aaa表";
        int columnNumber = 7;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "id" ,   "删除标识" ,   "名字" ,   "备注" ,   "图片" ,   "时间" ,   "多选"  };
        String[][] dataList = new String[testAaas.size()][7];

        for (int i = 0; i < testAaas.size(); i++) {

                        dataList[i][0] = String.valueOf(testAaas.get(i).getId());
                        dataList[i][1] = String.valueOf(testAaas.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(testAaas.get(i).getTestName());
                        dataList[i][3] = String.valueOf(testAaas.get(i).getRemark());
                        dataList[i][4] = String.valueOf(testAaas.get(i).getImageUrl());
                        dataList[i][5] = String.valueOf(testAaas.get(i).getTestTime());
                        dataList[i][6] = String.valueOf(testAaas.get(i).getMultiSelect());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

